% Compute transformation matrix describing local material directions.
% XYZ = location at which the material directions are needed
% ts = tangent vectors to parametric coordinates in columns
function Rmout = material_directions(self,XYZ,ts)
    Rm=get(self.feblock,'Rm');
    if isempty(Rm)
        Rmout=default_Rm(XYZ,ts);
    else
        if strcmp(class(Rm),'double')
            Rmout =Rm;
        elseif strcmp(class(Rm),'function_handle')
            Rmout= feval(Rm, XYZ, ts);
        end
    end
    return;
end