% Evaluate the Young's modulus, which may entail computing its position
% dependent value.
%   Call as:
%     E = get_E(m, context)
%   where
%     m=material
%    context=structure with optional field:
%                xyz = location of the material point
%
%
% the output arguments are
%     E = Young's modulus
%
function E = get_E(self, context)
    if strcmp (class(self.E),'double')
        E = self.E;
    else
        if isfield(context,'xyz')
            E=feval(self.E, context.xyz);
        else
            E =feval(self.E, []);
        end
    end
    return;
end
