% Evaluate the Poisson's ratio, which may entail computing its position
% dependent value.
%   Call as:
%     nu = nu(m, context)
%   where
%     m=material
%    context=structure with optional field:
%                xyz = location of the material point
%
%
% the output arguments are
%     nu = Poisson's ratio
%
function nu = get_nu(self, context)
    if strcmp (class(self.nu),'double')
        nu = self.nu;
    else
        if isfield(context,'xyz')
            nu=feval(self.nu, context.xyz);
        else
            nu =feval(self.nu, []);
        end
    end
    return;
end
