% Compute transformation matrix describing local material directions.
% XYZ = location at which the material directions are needed
% ts = tangent vectors to parametric coordinates in columns
% 
% This function assumes that it is being called for
% and n-dimensional manifold element, which is embedded in a
% n-dimensional Euclidean space. Therefore, the most obvious choice for
% the material directions is the identity: the local material directions
% aligned with the global Cartesian axes.
function Rm = default_Rm(XYZ,ts)
    Rm=eye(size(ts, 2));
end